namespace AutoGenerateColumns
{
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;
    using Telerik.Reporting;
    using Telerik.Reporting.Drawing;
    using System.Data.SqlClient;
    using System.Data;
    using System.Text;
    using System.Collections;

    /// <summary>
    /// Summary description for Report2.
    /// </summary>
    public partial class Report2 : Telerik.Reporting.Report
    {
        public Report2()
        {
            /// <summary>
            /// Required for telerik Reporting designer support
            /// </summary>
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        private void table1_ItemDataBinding(object sender, EventArgs e)
        {
            string connectionString = "Data Source=(local)\\SQLEXPRESS;Initial Catalog=AdventureWorks;Integrated Security=True";

            //get the processing table object since we're in the context of event
            Telerik.Reporting.Processing.Table processingTable = (sender as Telerik.Reporting.Processing.Table);
            //construct the select statement based on the selected report parameters
            string selectString = "SELECT " + FormatArray((object[])processingTable.Report.Parameters["TableColumns"].Value) + " FROM " + processingTable.Report.Parameters["TableName"].Label;
            SqlDataAdapter sqlAdapter = new SqlDataAdapter(selectString, connectionString);
            //create a dataset, fill it and set it as datasource to the processing table object
            DataSet ds = new DataSet();
            sqlAdapter.Fill(ds);
            processingTable.DataSource = ds.Tables[0];
            
            //create two HtmlTextBox items (one for header and one for data) which would be added to the items collection of the table
            Telerik.Reporting.TextBox textboxGroup;
            Telerik.Reporting.TextBox textboxGroup2;

            Telerik.Reporting.TextBox textBoxTable;

            //we do not clear the Rows collection, since we have a details row group and need to create columns only
            this.table1.ColumnGroups.Clear();
            this.table1.Body.Columns.Clear();
            this.table1.Body.Rows.Clear();
            int i = 0;
            this.table1.ColumnHeadersPrintOnEveryPage = true;
            foreach (DataColumn dc in ds.Tables[0].Columns)
            {
                Telerik.Reporting.TableGroup tableGroup = new Telerik.Reporting.TableGroup();
                Telerik.Reporting.TableGroup tableGroup2 = new Telerik.Reporting.TableGroup();
                tableGroup.ChildGroups.Add(tableGroup2);
                this.table1.ColumnGroups.Add(tableGroup);

                this.table1.Body.Columns.Add(new Telerik.Reporting.TableBodyColumn(Unit.Inch(1)));
               
                textboxGroup = new Telerik.Reporting.TextBox();
                textboxGroup.Style.BorderColor.Default = Color.Black;
                textboxGroup.Style.BorderStyle.Default = BorderType.Solid;
                textboxGroup.Value = "Header 2";
                textboxGroup.Size = new SizeU(Unit.Inch(1.1), Unit.Inch(0.3));
                tableGroup.ReportItem = textboxGroup;

                textBoxTable = new Telerik.Reporting.TextBox();
                textBoxTable.Style.BorderColor.Default = Color.Black;
                textBoxTable.Style.BorderStyle.Default = BorderType.Solid;
                textBoxTable.Value = "=Fields." + dc.ColumnName;
                textBoxTable.Size = new SizeU(Unit.Inch(1.1), Unit.Inch(0.3));
                this.table1.Body.SetCellContent(0, i++, textBoxTable);

                this.table1.Items.AddRange(new ReportItemBase[] { textBoxTable, textboxGroup });
            }
         
        }

        public static string FormatArray(IList array)
        {
            StringBuilder sb = new StringBuilder();

            foreach (object o in array)
            {
                if (sb.Length > 0)
                {
                    sb.Append(", ");
                }
                sb.Append(o.ToString());
            }

            return sb.ToString();
        } 
    }
}